Attribute VB_Name = "mdlBXLAPI"


Public Declare Function ConnectPrinter Lib "BXLPDC.dll" ( _
                                                ByVal szPrinterName As String _
                                                ) As Boolean

Public Declare Sub DisconnectPrinter Lib "BXLPDC.dll" ()

Public Declare Function Start_Doc Lib "BXLPDC.dll" ( _
                                            ByVal szDocName As String _
                                            ) As Boolean

Public Declare Sub End_Doc Lib "BXLPDC.dll" ()

Public Declare Function Start_Page Lib "BXLPDC.dll" () As Boolean

Public Declare Sub End_Page Lib "BXLPDC.dll" ()

Public Declare Function PrintDeviceFont Lib "BXLPDC.dll" ( _
                                            ByVal nPositionX As Long, ByVal nPositionY As Long, _
                                            ByVal szFontName As String, ByVal nFontSize As Long, ByVal szData As String _
                                            ) As Long

Public Declare Function PrintTrueFont Lib "BXLPDC.dll" ( _
                                            ByVal nPositionX As Long, ByVal nPositionY As Long, _
                                            ByVal szFontName As String, ByVal nFontSize As Long, ByVal szData As String, _
                                            Optional ByVal bBold As Boolean = False, Optional ByVal nRotation As Long = 0, _
                                            Optional ByVal bItalic As Boolean = False, Optional ByVal bUnderline As Boolean = False _
                                            ) As Long

Public Declare Function PrintBitmap Lib "BXLPDC.dll" ( _
                                            ByVal nPositionX As Long, ByVal nPositionY As Long, ByVal bitmapFile As String _
                                            ) As Long

'----------------------------------------------------------------------------------------
'----------------------------------------------------------------------------------------

'Calls the specified printer to use Status API.
Public Declare Function BidiOpenMonPrinter Lib "BXLPStatusBack.dll" (ByVal szPrinterName As String) As Boolean
'Closes Status API.
Public Declare Function BidiCloseMonPrinter Lib "BXLPStatusBack.dll" () As Boolean
'Provides notification regarding the call of the callback function notifying the application when the ASB status of Status API changes.
Public Declare Function BidiSetStatusBackFunction Lib "BXLPStatusBack.dll" (ByVal pFunc As Long) As Boolean
'Cancels the auto status notification function. This function is applicable to BiSetStatusBackFunction,
Public Declare Function BidiCancelStatusBack Lib "BXLPStatusBack.dll" () As Boolean
'Acquires the ASB status from Status API when required by the application.
Public Declare Function BidiGetStatus Lib "BXLPStatusBack.dll" () As Integer


Public Const PRN_STATUS_NORMAL = 0
Public Const PRN_STATUS_OFFLINE = 1
Public Const PRN_STATUS_PAPER_OUT = 2
Public Const PRN_STATUS_NEAR_END_ERR = 4
Public Const PRN_STATUS_DOOR_OPEN = 8

Public Const PRN_STATUS_CASHDRAWER_OPEN = 16
Public Const PRN_STATUS_AUTOCUTTER_ERR = 32
Public Const PRN_STATUS_MECHANICAL_ERR = 64
Public Const PRN_STATUS_UN_RECOVERABLE_ERR = 128


Public Function InterpretASBCommand(ByVal nStatus As Long) As Long
    If (nStatus = PRN_STATUS_NORMAL) Then
        MsgBox "PRN_STATUS_NORMAL"
    End If

    ' First
    If nStatus And PRN_STATUS_OFFLINE Then
        MsgBox "PRN_STATUS_OFFLINE"
    End If

    If nStatus And PRN_STATUS_DOOR_OPEN Then
        MsgBox "PRN_STATUS_DOOR_OPEN"
    End If
        
    If nStatus And PRN_STATUS_CASHDRAWER_OPEN Then
        MsgBox "PRN_STATUS_CASHDRAWER_OPEN"
    End If
        
    ' Second
    If nStatus And PRN_STATUS_MECHANICAL_ERR Then
        MsgBox "PRN_STATUS_MECHANICAL_ERR"
    ElseIf nStatus And PRN_STATUS_AUTOCUTTER_ERR Then
        MsgBox "PRN_STATUS_AUTOCUTTER_ERR"
    ElseIf nStatus And PRN_STATUS_UN_RECOVERABLE_ERR Then
        MsgBox "PRN_STATUS_UN_RECOVERABLE_ERR"
    End If

    ' Third
    If nStatus And PRN_STATUS_NEAR_END_ERR Then
        MsgBox "PRN_STATUS_NEAR_END_ERR"
    ElseIf nStatus And PRN_STATUS_PAPER_OUT Then
        MsgBox "PRN_STATUS_PAPER_OUT"
    End If
    
    InterpretASBCommand = nStatus
    
End Function


Public Function CallBackServiceMethod(ByVal nStatus As Integer) As Integer
   CallBackServiceMethod = InterpretASBCommand(nStatus)
End Function
    
